import { LobbyCreateRequest, LobbyListRequest } from "../define/Request/LobbyRequest";
import { INetResponse } from "../Engine/CatanEngine/NetManagerV2/Core/INetResponse";
import Room from "../Room/Room";

/**
 * Lobby
 */
export default class Lobby {

	//#region private

	private static list: Room[] = []
	private static serialNumber: number = 0

	//#endregion

	//#region Custom

	/** GetList */
	public static List(req: INetResponse<any>): void {
		const data = []
		for (let i = 0; i < this.list.length; i++) {
			const room = this.list[i];
			data.push(room.SerialNumber)
		}
		const resp: LobbyListRequest = new LobbyListRequest(data, 0)
		req.WS.SendClient(resp)
	}

	/** Create */
	public static Create(req: INetResponse<any>): void {
		const room: Room = new Room(Lobby.serialNumber, req.WS)
		Lobby.serialNumber++;
		this.list.push(room)
		const resp: LobbyCreateRequest = new LobbyCreateRequest()
		req.WS.SendClient(resp)
	}

	/** Join */
	public static Join(req: INetResponse<any>): void {
		//
	}

	/** Exit */
	public static Exit(req: INetResponse<any>): void {
		//
	}

	//#endregion
}
